/**********************************************************************
  oCit@CsR}h
  $Id: exec_cmd.c,v 1.12 2003/01/07 16:44:11 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

int	exception( struct MACHINE_RESOURCE *mres , int code ) ;

int	exec_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int	excp ;
int     id ;
int     res ;
int	break_flag ;
int     exec_mode ; 

 break_flag=ON ;
 id=proc_list.cur_id ;

 if( (mode & GO_EXEC_MODE)!=0 ){ //VKvZXforkĎs 
   res=create_proc( &proc_list, default_textsize ) ;
   if( res != NORMAL_EXIT ){
     SYSMSG("Failed to create process.\n") ;
     return( res ) ;
   }
   id=proc_list.cur_id ;
   res=elf_load(  &proc_list.proc[id], tk_pt->pt[1] ) ;
   if( res != NORMAL_EXIT ){
     remove_proc( &proc_list ) ;
     return( res ) ;
   }
   
   res=sim_setarg( &proc_list.proc[id], tk_pt, 1 ) ;
   if( res != NORMAL_EXIT ){
     if( res==SETARG_TOO_MANY_ARGS ){
       SYSMSG("too many arguments.\n") ;
     }
     remove_proc( &proc_list ) ;
     return( res ) ;
   }
   do{
     int i ;
     int leng ;
     for( i=0 ; i<(PNAME_LEN+1) ; i++ ) proc_list.proc[id].pname[i]='\0' ;
     leng=strlen(tk_pt->pt[1])+1 ;
     if( leng>=PNAME_LEN ) leng=PNAME_LEN ;
     strncpy( proc_list.proc[id].pname, tk_pt->pt[1], leng ) ;
   } while(0) ;
   
   iexe_count  = 0 ;
   break_flag=OFF ;
 }
   
 set_sighandl_ppcsim() ;
 while ( -1 ) {
   exec_mode=EXEC_INST ;
   
   if( sig_int != 0 ) break ;

   trace.buf[trace.ptr].pc   = proc_list.proc[id].pc ;
   trace.buf[trace.ptr].inst = proc_list.proc[id].inst ;
   trace.ptr=(trace.ptr+1)%trace.size ;
   
   iexe_count++ ;
   
   if( trace_stat.msg_type!=TRACE_OFF ){
     exec_mode |= EXEC_DIS ;
     print_regs( &proc_list.proc[id], trace_stat.print_type ) ;
   }
   
   if( proc_list.proc[id].bp_num > 0 ){
     int i ;
     for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].bp[i].ad ){
   	 if( break_flag==ON ){ //break|CgŎ~܂ĊJɂ܂Ȃlɂ
   	   break ;
   	 }else{
   	   SYSMSG("Exec stop by break point.\n") ;
	   op_exec(&proc_list.proc[id],EXEC_DIS) ;
   	   return(NORMAL_EXIT) ;     
   	 }
       }
     }
     break_flag=OFF ;
   }
   
   if( proc_list.proc[id].pp_num > 0 ){
     int i ;
     for( i=0 ; i<proc_list.proc[id].pp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].pp[i].ad ){
   	 SYSMSG("Passed count= ") ;
	 SYSMSGLL(iexe_count,0) ;
	 SYSMSG("\n") ;
	 switch( ppmsg_stat.msg_type ){
	 case PP_DUMP_PC :
	   exec_mode |= EXEC_DIS ;
	   break ;
	 default :
	   print_regs( &proc_list.proc[id], ppmsg_stat.print_type ) ;
	   break ;
	 }
   	 break ;
       }
     }
   }
   
   excp = op_exec( &proc_list.proc[id], exec_mode ) ;
   sim_io( &proc_list.proc[id] ) ;
   
   if( excp !=0 ){
     switch( excp ){
     case SYSCALLED_EXIT :
       remove_proc( &proc_list ) ;
       id=proc_list.cur_id ;
       if( id==0 ){
	 return(proc_list.proc[id].GPR[3].rl) ;
       }
       proc_list.proc[id].GPR[3].rl= 1 ;
       break ;
     case SYSCALLED_FORK :
       proc_list.proc[id].GPR[3].rl= 1 ; /** return value of parent process */
       res=sim_fork( &proc_list ) ;
       if( res!=NORMAL_EXIT ){
	 SYSMSG("fork() faild.\n") ;
	 print_regs( &proc_list.proc[id], PRINT_CRS|PRINT_GPRS ) ;
	 return(res) ;
       }
       id=proc_list.cur_id ;
       proc_list.proc[id].GPR[3].rl= 0 ; /** return value of child process */
       proc_list.proc[id].id       = id ;
       break ;
     case SYSCALLED_EXECVE :
       res=sim_execve( &proc_list.proc[id] ) ;
       if( res!=NORMAL_EXIT ){
	 SYSMSG("execve() faild.") ;
	 if( res==SETARG_TOO_MANY_ARGS ){
	   SYSMSG("too many arguments.") ;
	 }
	 SYSMSG("\n") ;
	 print_regs( &proc_list.proc[id], PRINT_CRS|PRINT_GPRS ) ;
	 return(res) ;
       }
       break ;
     case MEM_ACCESS_FAULT :
       SYSMSG("Memory access fault in syscall emulation.\n") ;
       print_regs( &proc_list.proc[id], PRINT_CRS|PRINT_GPRS ) ;
       return(NORMAL_EXIT) ;
       break ;
     default :
       excp=exception( &proc_list.proc[id], excp ) ;
       if( excp!=0 ) return(NORMAL_EXIT) ;
     }
   }
 }
 return(NORMAL_EXIT) ;
}


