/**********************************************************************
  WX^_v
  $Id: print_regs.c,v 1.5 2002/11/03 03:57:36 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	print_regs( struct MACHINE_RESOURCE *mres, int flag )
{
int i,j ;

  if( (flag & PRINT_GPRn)!=0 ){
    SYSMSG("GPR%02d : %08x\n",(flag&PRINT_ARGMSK),mres->GPR[(flag&PRINT_ARGMSK)].rl) ;
    return(NORMAL_EXIT) ;
  }
    
  if( (flag & PRINT_SPRS)!=0 ){
    for( i=0 ; i<1024 ; i+=8 ){
      SYSMSG("%04d : %08x %08x %08x %08x %08x %08x %08x %08x\n",i,
	     *mres->SPR[i+0],*mres->SPR[i+1],*mres->SPR[i+2],*mres->SPR[i+3],
	     *mres->SPR[i+4],*mres->SPR[i+5],*mres->SPR[i+6],*mres->SPR[i+7]) ;
    }
    return(NORMAL_EXIT) ;
  }
 
  if( (flag & PRINT_TRS)!=0 ){
    /** line1 **/
    SYSMSG("MSR   : %08x  ",*mres->MSR) ;
    SYSMSG("SDR1  : %08x\n",*mres->SPR[25]) ;
    /** line2 **/
    SYSMSG("IBAT0U: %08x  ",*mres->SPR[528]) ;
    SYSMSG("IBAT1U: %08x  ",*mres->SPR[530]) ;
    SYSMSG("IBAT2U: %08x  ",*mres->SPR[532]) ;
    SYSMSG("IBAT3U: %08x\n",*mres->SPR[534]) ;
    /** line3 **/
    SYSMSG("IBAT0L: %08x  ",*mres->SPR[529]) ;
    SYSMSG("IBAT1L: %08x  ",*mres->SPR[531]) ;
    SYSMSG("IBAT2L: %08x  ",*mres->SPR[533]) ;
    SYSMSG("IBAT3L: %08x\n",*mres->SPR[535]) ;
    /** line4 **/
    SYSMSG("DBAT0U: %08x  ",*mres->SPR[536]) ;
    SYSMSG("DBAT1U: %08x  ",*mres->SPR[538]) ;
    SYSMSG("DBAT2U: %08x  ",*mres->SPR[540]) ;
    SYSMSG("DBAT3U: %08x\n",*mres->SPR[542]) ;
    /** line5 **/
    SYSMSG("DBAT0L: %08x  ",*mres->SPR[537]) ;
    SYSMSG("DBAT1L: %08x  ",*mres->SPR[539]) ;
    SYSMSG("DBAT2L: %08x  ",*mres->SPR[541]) ;
    SYSMSG("DBAT3L: %08x\n",*mres->SPR[543]) ;
    /** line6 **/
    SYSMSG("SR00  : %08x  ",*mres->SR[0]) ;
    SYSMSG("SR01  : %08x  ",*mres->SR[1]) ;
    SYSMSG("SR02  : %08x  ",*mres->SR[2]) ;
    SYSMSG("SR03  : %08x\n",*mres->SR[3]) ;
    /** line7 **/
    SYSMSG("SR04  : %08x  ",*mres->SR[4]) ;
    SYSMSG("SR05  : %08x  ",*mres->SR[5]) ;
    SYSMSG("SR06  : %08x  ",*mres->SR[6]) ;
    SYSMSG("SR07  : %08x\n",*mres->SR[7]) ;
    /** line8 **/
    SYSMSG("SR08  : %08x  ",*mres->SR[8]) ;
    SYSMSG("SR09  : %08x  ",*mres->SR[9]) ;
    SYSMSG("SR10  : %08x  ",*mres->SR[10]) ;
    SYSMSG("SR11  : %08x\n",*mres->SR[11]) ;
    /** line9 **/
    SYSMSG("SR12  : %08x  ",*mres->SR[12]) ;
    SYSMSG("SR13  : %08x  ",*mres->SR[13]) ;
    SYSMSG("SR14  : %08x  ",*mres->SR[14]) ;
    SYSMSG("SR15  : %08x\n",*mres->SR[15]) ;
    //    return(NORMAL_EXIT) ;
  }
 
  /** line 1 **/
  if( (flag & PRINT_CRS)!=0 ){
    SYSMSG("PC    : %08x  ",mres->pc) ;
    SYSMSG("MSR   : %08x  ",*mres->MSR) ;
    SYSMSG("SPRG0 : %08x  ",*mres->SPR[272]) ;
    SYSMSG("DEC   : %08x\n",*mres->SPR[22]) ;
    /** line 2 **/ 
    SYSMSG("CR    : %01x%01x%01x%01x%01x%01x%01x%01x  ",
	   mres->FLGR.cr[0]>>28,
	   mres->FLGR.cr[1]>>28,
	   mres->FLGR.cr[2]>>28,
	   mres->FLGR.cr[3]>>28,
	   mres->FLGR.cr[4]>>28,
	   mres->FLGR.cr[5]>>28,
	   mres->FLGR.cr[6]>>28,
	   mres->FLGR.cr[7]>>28) ;
    SYSMSG("SRR0  : %08x  ",*mres->SPR[26]) ;
    SYSMSG("SPRG1 : %08x  ",*mres->SPR[273]) ;
    SYSMSG("TBU   : %08x\n",*mres->TBU) ;
    /** line 3 **/ 
    SYSMSG("XER   : %08x  ",mres->FLGR.xer) ;
    SYSMSG("SRR1  : %08x  ",*mres->SPR[27]) ;
    SYSMSG("SPRG2 : %08x  ",*mres->SPR[274]) ;
    SYSMSG("TBL   : %08x\n",*mres->TBL) ;
    /** line 4 **/ 
    SYSMSG("LR    : %08x  ",mres->FLGR.lrl) ;
    SYSMSG("HID0  : %08x  ",*mres->SPR[1008]) ;
    SYSMSG("SPRG3 : %08x  ",*mres->SPR[275]) ;
    SYSMSG("FPSCR : %08x\n",mres->FLGR.fpscr) ;
    /** line 5 **/ 
    SYSMSG("CTR   : %08x  ",mres->FLGR.ctrl) ;
    SYSMSG("HID1  : %08x  ",*mres->SPR[1009]) ;
    SYSMSG("SDR1  : %08x\n",*mres->SPR[25]) ;
    /** line 6 **/ 
    SYSMSG("GPR   : \n") ;
    SYSMSG("00-07 : %08x %08x %08x %08x %08x %08x %08x %08x\n",
	   mres->GPR[ 0].rl,
	   mres->GPR[ 1].rl,
	   mres->GPR[ 2].rl,
	   mres->GPR[ 3].rl,
	   mres->GPR[ 4].rl,
	   mres->GPR[ 5].rl,
	   mres->GPR[ 6].rl,
	   mres->GPR[ 7].rl) ;
    SYSMSG("08-15 : %08x %08x %08x %08x %08x %08x %08x %08x\n",
	   mres->GPR[ 8].rl,
	   mres->GPR[ 9].rl,
	   mres->GPR[10].rl,
	   mres->GPR[11].rl,
	   mres->GPR[12].rl,
	   mres->GPR[13].rl,
	   mres->GPR[14].rl,
	   mres->GPR[15].rl) ;
    SYSMSG("16-23 : %08x %08x %08x %08x %08x %08x %08x %08x\n",
	   mres->GPR[16].rl,
	   mres->GPR[17].rl,
	   mres->GPR[18].rl,
	   mres->GPR[19].rl,
	   mres->GPR[20].rl,
	   mres->GPR[21].rl,
	   mres->GPR[22].rl,
	   mres->GPR[23].rl) ;
    SYSMSG("24-31 : %08x %08x %08x %08x %08x %08x %08x %08x\n",
	   mres->GPR[24].rl,
	   mres->GPR[25].rl,
	   mres->GPR[26].rl,
	   mres->GPR[27].rl,
	   mres->GPR[28].rl,
	   mres->GPR[29].rl,
	   mres->GPR[30].rl,
	   mres->GPR[31].rl) ;
  }
  
  if( (flag & PRINT_FPRS)!=0 ){
    /* CPUA[LeN`ˑǂ̂..... */
    unsigned int *fpr_u, *fpr_l ;
    
    SYSMSG("FPR   :\n") ;
    for( i=0 ; i<8 ; i++ ){
      SYSMSG("%02d-%02d :",i*4,i*4+3) ;
      for( j=0 ; j<4 ; j++ ){
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
	fpr_l=(unsigned int*)&mres->FPR[i*4+j].f ;
	fpr_u=fpr_l+1 ;
#else
	fpr_u=&mres->FPR[i*4+j].f ;
	fpr_l=fpr_u+1 ;
#endif
	SYSMSG(" %08x%08x ",*fpr_u,*fpr_l) ;
      }
      SYSMSG("\n") ;
    }
  }
 return(NORMAL_EXIT) ;
}
