/**********************************************************************
  execve G~[V
  $Id: sim_execve.c,v 1.4 2003/01/07 16:44:12 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "op_scemu.h"

int	sim_execve( struct MACHINE_RESOURCE *mres )
{
  int res ;
  struct	TOKEN_STRUCT	token ;
  int     ptr ;
  int     i,cmdlen ;
  int     arglen ;
  unsigned char *cmdptr, *cmdline, *cmdname ;
  int ret ;

  token.str=NULL ;
  ret=NORMAL_EXIT ;
  
  ChkMemStr(mres,mres->GPR[3].rl,res) ;
  if( res!=0 ) { ret=-1 ; goto Error3 ; }
  cmdlen=strlen(&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)]) ;
  cmdptr=NULL ;
  arglen=0 ;
  for( i=cmdlen-1 ; i>-1 ; i-- ){
    cmdptr=&mres->mem[seg(mres->GPR[3].rl+i)][lad(mres->GPR[3].rl+i)] ;
    if( *cmdptr=='/' ){
      cmdptr++ ;
      break ;
    }
  }
  arglen+=strlen(cmdptr)+1 ;
  cmdname=malloc(arglen+1) ;
  strcpy(cmdname,cmdptr) ;
  
  /** ̎荞 **/
  for( i=0 ; ; i+=4 ){
    ChkMemRange(mres,mres->GPR[4].rl+3,res) ;
    if( res!=0 ) { ret=-1 ; goto Error2 ; }
    ptr =mres->mem[seg(mres->GPR[4].rl+i+0)][lad(mres->GPR[4].rl+i+0)]*0x01000000 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+1)][lad(mres->GPR[4].rl+i+1)]*0x00010000 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+2)][lad(mres->GPR[4].rl+i+2)]*0x00000100 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+3)][lad(mres->GPR[4].rl+i+3)]*0x00000001 ;
    if( ptr==0x00000000 ) break ;
    ChkMemStr(mres,ptr,res) ;
    if( res!=0 ) { ret=-1 ; goto Error2 ; }
    arglen+=strlen(&mres->mem[seg(ptr)][lad(ptr)])+1 ;
  }
  
  cmdline=malloc(arglen+2) ;
  cmdline[0]='\0' ;
  for( i=0,arglen=0 ; ; i+=4 ){ //Ȃ񂩏璷....(^_^;;;
    ptr =mres->mem[seg(mres->GPR[4].rl+i+0)][lad(mres->GPR[4].rl+i+0)]*0x01000000 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+1)][lad(mres->GPR[4].rl+i+1)]*0x00010000 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+2)][lad(mres->GPR[4].rl+i+2)]*0x00000100 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+3)][lad(mres->GPR[4].rl+i+3)]*0x00000001 ;
    if( ptr==0x00000000 ) break ;
    strcat( cmdline, &mres->mem[seg(ptr)][lad(ptr)] ) ;
    strcat( cmdline, " " ) ;
  }
  get_token( cmdline , &token ) ;
  
  init_regs( mres ) ;

#ifdef SUPPORT_SYSTEMCALL_EMULATION
  sim_munmap_all(mres) ;
  for( i=0 ; i<MEM_SEGMENT_NUM ; i++ ){
    if( mres->mem_attr[i]==MEM_ATTR_NORMAL ){
      memclear( mres , i, mres->mem_size[i] ) ;
    }
  }
#endif
  
  for( i=3 ; i<MAX_OPEN_FD ; i++ ){ /** stdioȊOfildesN[Y **/
    close_fd( mres, i ) ;
  }
  
  mres->heap_top = default_heaptop ;
  mres->heap_size= default_heapsize ;
  mres->heap_cur = 0 ;
  mres->brk_top  = default_brktop ;
  mres->brk_size = default_brksize ;
  mres->brk_cur  = 0 ;
  mres->pc       = default_exec_start ;
  mres->GPR[1].rl= mres->mem_size[TEXT_SEG_TOP] - default_stack_top_offset ;

  res=elf_load(  mres, cmdname ) ;
  if( res != NORMAL_EXIT ) return( res ) ;
  res=sim_setarg( mres, &token, 0 ) ;
  if( res != NORMAL_EXIT ) return( res ) ;
  do{
    int i ;
    int leng ;
    for( i=0 ; i<(PNAME_LEN+1) ; i++ ) mres->pname[i]='\0' ;
    leng=strlen(cmdline)+1 ;
    if( leng>=PNAME_LEN ) leng=PNAME_LEN ;
    strncpy( mres->pname, cmdline, leng ) ;
  } while(0) ;

  free( cmdline ) ;
 Error2:
  free( cmdname ) ;
 Error3: 
  return(ret) ;
}
